/*
 * linux/arch/mips/tx4925/toshiba_rbtx4925/led.c
 *
 * sample code RBTX4925 leds
 *
 * Author: MontaVista Software, Inc.  source@mvista.com
 *
 * 2003 (c) MontaVista Software, Inc. This file is licensed under
 * the terms of the GNU General Public License version 2. This program
 * is licensed "as is" without any warranty of any kind, whether express
 * or implied.
 */

#include <linux/errno.h>
#include <linux/init.h>
#include <linux/kernel_stat.h>
#include <linux/module.h>
#include <linux/signal.h>
#include <linux/sched.h>
#include <linux/types.h>
#include <linux/interrupt.h>
#include <linux/ioport.h>
#include <linux/timex.h>
#include <linux/slab.h>
#include <linux/random.h>
#include <linux/irq.h>
#include <asm/bitops.h>
#include <asm/bootinfo.h>
#include <asm/io.h>
#include <asm/irq.h>
#include <asm/mipsregs.h>
#include <asm/system.h>
#include <asm/tx4925/tx4925.h>

#define TX4925_LED_BASE 0xbb001000

u8
tx4925_led_get(void)
{
	return (TX4925_RD08(TX4925_LED_BASE));
}

u8
tx4925_led_set(u8 value)
{
	u8 orig;

	orig = tx4925_led_get();
	TX4925_WR08(TX4925_LED_BASE, value);
}
