/*
 * This program is free software; you can redistribute  it and/or modify it
 * under  the terms of  the GNU General  Public License as published by the
 * Free Software Foundation;  either version 2 of the  License, or (at your
 * option) any later version.
 *
 * Copyright (C) 1997, 2001 Ralf Baechle
 * Copyright 2001 MontaVista Software Inc.
 * Author: jsun@mvista.com or jsun@junsun.net
 */

/*
 * 2003/11/15 Rewrote vr41xx_restart() using PMU by Sony Corporation.
 * 2003/11/15 Added hibernation in vr41xx_power_off() by Sony Corporation.
 */

#include <asm/io.h>
#include <asm/pgtable.h>
#include <asm/processor.h>
#include <asm/reboot.h>
#include <asm/system.h>

#include <linux/sched.h>
#include <linux/mm.h>
#include <linux/module.h>

#ifdef CONFIG_FOR_OPTICAL_DISK_
#include <asm/vr4122/vr4122.h>
#endif

void vr41xx_restart(char *command)
{
#ifdef CONFIG_FOR_OPTICAL_DISK_ 
	writew(readw(VR4122_PMUCNT2REG) | 0x0010, VR4122_PMUCNT2REG);
#endif
	change_c0_status((ST0_BEV | ST0_ERL), (ST0_BEV | ST0_ERL));
	change_c0_config(CONF_CM_CMASK, CONF_CM_UNCACHED);
	flush_cache_all();
	write_c0_wired(0);
	__asm__ __volatile__("jr\t%0"::"r"(0xbfc00000));
}

void vr41xx_halt(void)
{
	printk(KERN_NOTICE "\n** You can safely turn off the power\n");
	while (1);
}

void vr41xx_power_off(void)
{
#ifdef CONFIG_MIPS_BSNC_DIF144 /* _FOR_OPTICAL_DISK_ */
	u32 status;
	u8 bitmap;

	printk("hibernate...\n");

	bitmap = 1<<2 | /* PCCARD_SHT_DWN_X */
		 1<<4 | /* LNX_PCCARD_DWN_X */
		 1<<5 ; /* LNX_OSD_DWN_X */

	dif144_dev_clock(bitmap, 0);

	status = read_c0_status();
	write_c0_status(status & ~CAUSEF_IP7);

	__asm__ (" .set\tnoreorder\n\t"
		 ".word\t0x42000023\n\t" /* hibernate */
		 " nop\n"
		 " nop\n"
		 " nop\n"
		 " nop\n"
		 " .set\treorder\n");
#else
	vr41xx_halt();
#endif
}

