/* _FOR_OPTICAL_DISK_ */

/*
 * BRIEF MODULE DESCRIPTION
 *	Sony BSNC DIF-144 Board specific prom's initialization.
 *
 * Copyright 2002, 2003, 2004, 2005 Sony Corporation
 *
 * Derived from arch/mips/vr41xx/nec-eagle/init.c
 *                   Copyright 2001,2002 MontaVista Software Inc.
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU General  Public License as published by the
 *  Free Software Foundation;  either version 2 of the  License, or (at your
 *  option) any later version.
 *
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU General Public License along
 *  with this program; if not, write  to the Free Software Foundation, Inc.,
 *  675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*
 *  Changes:
 *
 *  2004/12/07 Sony Corporation
 *  	* Append "video=vfb" to kernel parameters (CONFIG_BSNC_CAM_PM=y).
 */

#include <linux/config.h>
#include <linux/init.h>
#include <linux/kernel.h>
#include <linux/string.h>

#include <asm/bootinfo.h>

#ifdef CONFIG_ROOT_NFS
#include <asm/io.h>
#include <asm/vr41xx/dif144.h>
#endif

char arcs_cmdline[CL_SIZE];

const char *get_system_type(void)
{
	return "DIF-144/DPR-238/DVP-27";
}

void __init prom_init(int argc, char **argv, unsigned long magic, int *prom_vec)
{
	int i;
#ifdef CONFIG_ROOT_NFS
	u16 val;
#endif

	/*
	 * collect args and prepare cmd_line
	 */
#ifdef CONFIG_ROOT_NFS
	/* clear haltimer */
	val = readw(KSEG1ADDR(0x0F0000C2));
	writew(val | 0x4, KSEG1ADDR(0x0F0000C2));
#else
	for (i = 1; i < argc; i++) {
		strcat(arcs_cmdline, argv[i]);
		if (i < (argc - 1))
			strcat(arcs_cmdline, " ");
	}
#endif

#ifdef CONFIG_SERIAL_CONSOLE
        /* to use 115200 ttyS0 serial console */
	strcat(arcs_cmdline, " console=ttyS0,115200");
#endif

#ifdef CONFIG_BSNC_CAM_PM
	strcat(arcs_cmdline, " video=vfb");
#endif

	mips_machgroup = MACH_GROUP_NEC_VR41XX;
	mips_machtype = MACH_BSNC_DIF144;

	add_memory_region(0,  64 << 20, BOOT_MEM_RAM);
}

void __init prom_free_prom_memory (void)
{
}
