/* _FOR_OPTICAL_DISK_ */

/*
 * BRIEF MODULE DESCRIPTION
 *	Sony BSNC DIF-144 Board specific PCI fixups.
 *
 * Copyright 2002, 2003, 2004, 2005 Sony Corporation
 *
 * Derived from arch/mips/vr41xx/nec-eagle/pci_fixup.c
 *                   Copyright 2001,2002 MontaVista Software Inc.
 * 	
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU General  Public License as published by the
 *  Free Software Foundation;  either version 2 of the  License, or (at your
 *  option) any later version.
 *
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU General Public License along
 *  with this program; if not, write  to the Free Software Foundation, Inc.,
 *  675 Mass Ave, Cambridge, MA 02139, USA.
 */
#include <linux/config.h>
#include <linux/init.h>
#include <linux/pci.h>

#include <asm/vr41xx/dif144.h>

void __init pcibios_fixup_resources(struct pci_dev *dev)
{
}

void __init pcibios_fixup(void)
{
}

void __init pcibios_fixup_irqs(void)
{
	struct pci_dev *dev;

	pci_for_each_dev(dev) {
		switch (dev->vendor) {
		case PCI_VENDOR_ID_TI:
			if (dev->device == PCI_DEVICE_ID_TI_1510) {
				dev->irq = BSNC_DIF144_IRQ_TI_PCI1510;
			}
			break;
		case PCI_VENDOR_ID_INTERG: /* TVIA */
			if (dev->device == PCI_DEVICE_ID_INTERG_5202) {
				dev->irq = BSNC_DIF144_IRQ_OSD;
			}
			break;
		case PCI_VENDOR_ID_INTEL:
			if (dev->device == PCI_DEVICE_ID_INTEL_82557) {
				dev->irq = GIU_IRQ(10);
			} else if (dev->device == PCI_DEVICE_ID_INTEL_82559ER) {
				dev->irq = BSNC_DPR238_IRQ_ETHER;
			} else if (dev->device == PCI_DEVICE_ID_INTEL_21555) {
				/* P2P Bridge Intel 21555 */
				dev->irq = BSNC_DIF144_IRQ_INTEL_21555;
			}
			break;
		default:
			continue;
		}
		pci_write_config_byte(dev, PCI_INTERRUPT_LINE, dev->irq);
	}
}


unsigned int pcibios_assign_all_busses(void)
{
	return 0;
}
