/*
 *  linux/include/asm-i386/snsc_mpu300.h
 *
 *  Copyright 2002 Sony Corporation.
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU General  Public License as published by the
 *  Free Software Foundation;  version 2 of the  License.
 *
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU General Public License along
 *  with this program; if not, write  to the Free Software Foundation, Inc.,
 *  675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef _SNSC_MPU300_H_
#define _SNSC_MPU300_H_

#include <linux/config.h>
#include <linux/types.h>

#ifdef CONFIG_SNSC_CONST_LPJ
#include <asm/timex.h>

/* constant loops_per_jiffy */
static __inline__ unsigned long
lookup_lpj(void)
{
        if ((390000 < cpu_khz) && (cpu_khz < 410000)) {
                return 3981312;
        }
        
        if ((490000 < cpu_khz) && (cpu_khz < 510000)) {
                return 4964352;
        }

        return 0;
}
#endif

#define MPU300_BOOT_TIME_BASE         0x9e000
#define MPU300_BOOT_TIME_SIZE         0x1000

#ifdef MPU300_DEBUG
#  ifdef __KERNEL__
#    define PDEBUG(fmt, args...)    printk(fmt, ## args)
#  else /* __KERNEL__ */
#    define PDEBUG(fmt, args...)    fprintf(stderr, fmt, ## args)
#  endif /* __KERNEL__ */
#else
#  define PDEBUG(fmt, args...)
#endif

#endif /* _SNSC_MPU300_H_ */
