/*
 *  linux/include/asm-i386/snsc_mpu30x_powctrl.h
 *
 *  Copyright 2003 Sony Corporation.
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU General  Public License as published by the
 *  Free Software Foundation;  version 2 of the  License.
 *
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU General Public License along
 *  with this program; if not, write  to the Free Software Foundation, Inc.,
 *  675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef _SNSC_MPU30X_POWCTRL_H_
#define _SNSC_MPU30X_POWCTRL_H_

#include <linux/config.h>
#include <linux/ioctl.h>
#include <linux/snsc_powctrl.h>

/* wakeup flag */
#define WAKEUP_WOL        0x00000001     /* Wake On LAN */
#define WAKEUP_RI0        0x00000002     /* Wake On Ring(UART0) */
#define WAKEUP_RI1        0x00000004     /* Wake On Ring(UART1) */
#define WAKEUP_RTC        0x00000008     /* RTC Alarm */
/*#define WAKEUP_AC97       0x00000010     /* AC'97 */
#define WAKEUP_SMB        0x00000020     /* SMBALERT# */
#define WAKEUP_WDRST      0x00004000     /* Watchdog reset */
#define WAKEUP_PWRBTN     0x00008000     /* Power Button */
#define WAKEUP_SGPIO0     0x00010000     /* Super I/O GPIO0 */
#define WAKEUP_SGPIO1     0x00020000     /* Super I/O GPIO1 */
#define WAKEUP_SGPIO2     0x00040000     /* Super I/O GPIO2 */
#define WAKEUP_SGPIO3     0x00080000     /* Super I/O GPIO3 */
#define WAKEUP_SGPIO4     0x00100000     /* Super I/O GPIO4 */
#define WAKEUP_SGPIO5     0x00200000     /* Super I/O GPIO5 */
#define WAKEUP_SGPIO6     0x00400000     /* Super I/O GPIO6 */
#define WAKEUP_SGPIO7     0x00800000     /* Super I/O GPIO7 */
#define WAKEUP_SGPIO8     0x01000000     /* Super I/O GPIO8 */
#define WAKEUP_SGPIO9     0x02000000     /* Super I/O GPIO9 */
#define WAKEUP_SGPIO_ALL  0x03ff0000

/* ioctl */
#define SNSC_POWCTRL_IOC_SET_WAKEUP      _IO(SNSC_POWCTRL_IOC_MAGIC, 2)
#define SNSC_POWCTRL_IOC_UNSET_WAKEUP    _IO(SNSC_POWCTRL_IOC_MAGIC, 3)
#define SNSC_POWCTRL_IOC_GET_SETTINGS    \
	_IOR(SNSC_POWCTRL_IOC_MAGIC, 4, u_int32_t)
#define SNSC_POWCTRL_IOC_GET_WUPCAUSE    \
	_IOR(SNSC_POWCTRL_IOC_MAGIC, 5, u_int32_t)

#endif /* _SNSC_MPU30X_POWCTRL_H_ */
