/*
 *  Sony NSC NBLArgs architecture difinition
 *
 *  Copyright 2001-2003 Sony Corporation.
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU General  Public License as published by the
 *  Free Software Foundation;  version 2 of the  License.
 *
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU General Public License along
 *  with this program; if not, write  to the Free Software Foundation, Inc.,
 *  675 Mass Ave, Cambridge, MA 02139, USA.
 */
#ifndef __ARCH_NBLARGS_H__
#define __ARCH_NBLARGS_H__

#include <linux/autoconf.h>
#include <asm/page.h>

/* For MPU-210 */
#ifdef CONFIG_MIPS_SNSC_MPU210
#include <asm/it8172/snsc_mpu210.h>
#endif	/* CONFIG_MIPS_SNSC_MPU210 */

/* For MPU-22x */
#ifdef CONFIG_SNSC_MPU22X
#include <asm-mips/tx4927/snsc_mpu22x/snsc_mpu22x.h>
#endif	/* CONFIG_SNSC_MPU22X */

/* 
 * platform default NBLArgs address and size
 */
#ifndef CONFIG_SNSC_NBLARGS_STD_ADDR
#define CONFIG_SNSC_NBLARGS_STD_ADDR        NBLARGS_STD_ADDR
#endif

#ifndef CONFIG_SNSC_NBLARGS_STD_LEN
#define CONFIG_SNSC_NBLARGS_STD_LEN         NBLARGS_STD_LEN
#endif

/* 
 * NBLArgs address translation
 */

#define nbl_to_va(x)                     (x)
#define nbl_to_pa(x)                     __pa((x))

#endif /* __ARCH_NBLARGS_H__ */
