/* _FOR_OPTICAL_DISK_ */

/*
 * BRIEF MODULE DESCRIPTION
 *	The interface driver to access Sony XDCAM specific functions
 *
 * Copyright (C) 2003, 2004, 2005 Sony Corporation
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#ifndef __DIF144CONF_H
#define __DIF144CONF_H

#include <linux/ioctl.h>

#define DIF144CONF_MAGIC 'D'
#define DIF144CONF_HALTIMER_CLEAR  _IO(DIF144CONF_MAGIC, 0)
#define DIF144CONF_HIBERNATE       _IO(DIF144CONF_MAGIC, 1)
#define DIF144CONF_TP_HI           _IOW(DIF144CONF_MAGIC, 2, unsigned char)
#define DIF144CONF_TP_LOW          _IOW(DIF144CONF_MAGIC, 3, unsigned char)
#define DIF144CONF_DEV_ON          _IOW(DIF144CONF_MAGIC, 4, unsigned char)
#define DIF144CONF_DEV_OFF         _IOW(DIF144CONF_MAGIC, 5, unsigned char)
#define DIF144CONF_CHECK_BOOTMODE  _IO(DIF144CONF_MAGIC, 6)

#endif /* __DIF144CONF_H */

